# include "window.h"

# include <cstdio>

# include <QWidget>
# include <QSlider>
# include <QSpinBox>
# include <QDoubleSpinBox>
# include <QVBoxLayout>

Window :: Window ( QWidget * parent ) : QWidget ( parent )
{
	slider = new QSlider ;
	slider -> setMinimum ( 0 ) ;
	slider -> setMaximum ( 100 ) ;
	slider -> setValue ( 50 ) ;

	spin = new QSpinBox ;
	spin -> setMinimum ( 0 ) ;
	spin -> setMaximum ( 100 ) ;
	spin -> setValue ( 50 ) ;

	dblSpin = new QDoubleSpinBox ;
	dblSpin -> setDecimals ( 2 ) ;
	dblSpin -> setMinimum ( 0 ) ;
	dblSpin -> setMaximum ( 1 ) ;
	dblSpin -> setSingleStep ( 0.01 ) ;
	dblSpin -> setValue ( 0.5 ) ;

	QVBoxLayout * layout = new QVBoxLayout ;
	layout -> addWidget ( slider, 0, Qt :: AlignHCenter ) ;
	layout -> addWidget ( spin ) ;
	layout -> addWidget ( dblSpin ) ;

	this -> setLayout ( layout ) ;
	this -> setWindowTitle ( "C++ Slider Test" ) ;

	connect ( slider , SIGNAL ( valueChanged ( int    ) ), this, SLOT ( sliderMoved    ( int    ) ) ) ;
	connect ( spin   , SIGNAL ( valueChanged ( int    ) ), this, SLOT ( spinChanged    ( int    ) ) ) ;
	connect ( dblSpin, SIGNAL ( valueChanged ( double ) ), this, SLOT ( dblSpinChanged ( double ) ) ) ;
}

void Window :: sliderMoved ( int scaledTime )
{
	printf ( "sliderMoved: %d\n", scaledTime ) ;
	spin    -> setValue ( scaledTime       ) ;
	dblSpin -> setValue ( scaledTime / 100.0 ) ;
}

void Window :: spinChanged ( int scaledTime )
{
	printf ( "spinChanged: %d\n", scaledTime ) ;
	slider  -> setValue ( scaledTime       ) ;
	dblSpin -> setValue ( scaledTime / 100.0 ) ;	
}

void Window :: dblSpinChanged ( double time )
{
	printf ( "dblSpinChanged: %6.4f\n", time ) ;
	slider -> setValue ( time * 100 ) ;
	spin   -> setValue ( time * 100 ) ;
}
